Instructions Unclear: Undefined Behaviour in Cellular Network Specifications
============================================================================

These are the artifacts belonging to our paper "Instructions Unclear: Undefined Behaviour in Cellular Network Specifications", accepted at Usenix Security 2023.
There are artifacts of two different kinds: Tla+-models and srsran forks. The former are used to check the LTE specifications of the Public Warning System (PWS, also known as Wireless Emergency Alert), SMS and RRC components, for undefined behaviour. They can also be used to generate counter examples. Such counter examples are PDU sequences, where each PDU has a concrete variable assignement. These can then be replayed via srsRAN. We provide three srsRAN forks, that replay representative counter examples.


TLA+ models
===========

Please see `models/README.md` for more information.

srsRAN
======

**CAUTION: This software can be used to operate a local LTE cell. This is a heavily regulated area, and without proper precautions you might break the law or even cause harm by interrupting the accessibility of commercial LTE networks. Proceed at you own risk, read applicable laws and the manuals of your SDR and srsRAN. Always use an RF shielding box.**

Building
--------

Our forks can be built by following the [upstream srsRAN documentation](https://docs.srsran.com/projects/4g/en/latest/general/source/1_installation.html#installation-from-source).

Usage
-----

By default, our forks operate similar to the upstream srsRAN versions. If you do not specify any test case, they are operating as a regular cell and require the same configuration as upstream srsRAN. We recommend ensuring that your local cell works correctly before preoceeding.


### PWS

Ensure that you schedule SIB12 in your `sib.conf`, then start enb and epc. Test cases are configured in `srsran/pws/srsenb/src/stack/rrc/rrc.cc`. To tigger a test case, type the number of the test case (see `rrc.cc` for number to test case mappings) in the enb window and press enter. For sequences, repeat this process as often as there are PDUs in the sequence.

### SMS

Before starting enb and epc start `srsran/sms/zmq_server/zmq_server.py`.
Similarly to the PWS fork, you send test SMS by entering their index, but in this case into the ZMQ server window. If you want to modify the test cases, you can do so in `srsran/sms/srsepc/src/mme/sms.cc`.

### RRC

When starting the enb, you must supply the name of the test case via the `--test_case` command line argument. For the test cases that require that security is disabled (all test cases containing `_NO_CIPHERING_`) you must configure `EEA0` encryption in the `enb.conf` (`eea_pref_list = EEA0`).

All tests require that you restart enb and epc after each test. You must also restart the phone, and in case of the PWS tests increment the system time to expire the internal message cache of incompletely received messages.

**For detailed experiment information, please consult the Artifact Appendix.**