# TLA+ models "Instructions Unclear: Undefined Behavior in Cellular Network Specifications"

This repository contains the TLA+ models used in the paper "Instructions Unclear: Undefined Behavior in Cellular Network Specifications". All models are already fully extended with blocking clauses to allow the synthesis of counter examples for the undefined behaviours listed in the appendix of the paper. These counter examples can then be integrated in an LTE network implementation of your choice, e.g., srsRAN. We intend to publish assistive scripts and patch-files for srsRAN upon publication.

## How to use the models

1. Install TLA+. We recommend using the CLI wrappers and installer from https://github.com/pmer/tla-bin
2. `cd` into the directory of the model you want to try out
3. Open the corresponding `.tla` file with the editor of your choice
4. Find the line that says `ConstTestCase == NO_TEST` and replace `NO_TEST` by the name of the undefined behaviour that you want to generate a counter example for. For instance, set  `ConstTestCase == LAST_MESSAGE_BUT_FURTHER_MESSAGES` to generate a sequence for "CVE-2022-XXXXX (1)". This disables the blocking clause for this undefined behaviour.
5. Save your changes.
6. Run `tlc -deadlock -workers auto -maxSetSize 10000000 pws` (or `sms`, `rrc`)
7. An invariant violation will be detected and printed to stdout. The sequence is stored in the `currentSequence` of the last generated state

## How to generate blocking clauses yourself

If you want to generate your own blocking clauses then

1. Erase the formula fragments between `\* START OF BLOCKING CLAUSES` and `\* END OF BLOCKING CLAUSES`
2. Set `ConstTestCase == NO_TEST` 
3. Run `tlc` as explained above
4. Once an invariant violation is detected: Apply the procedure from section 3.4 of the paper
5. Go back to step 3 until no more invariant violations are found
