#ifndef TEST_CASES_H
#define TEST_CASES_H


namespace srsenb {
    enum test_case_e {
        No_Test,
        RRCConnectionSetupMessage_DRB_WITHOUT_SECURITY,
        RRCConnectionSetupMessage_SRB2_WITHOUT_SECURITY,
        RRCConnectionSetupMessage_AFTER_SECURITY_ENABLED,
        RRCConnectionReconfigurationMessage_INVALID_DRB_CONFIG,
        RRCConnectionReconfigurationMessage_INVALID_SRB_CONFIG,
        RRCConnectionReconfigurationMessage_UNPROTECTED_SECURITY_CONFIG,
        RRCConnectionReconfigurationMessage_UNPROTECTED_MOBILITY_CONTROL, // DO NOT USE
        RRCConnectionReconfigurationMessage_UNPROTECTED_SPEED_STATE_PARS,
        RRCConnectionReconfigurationMessage_UNPROTECTED_MEAS_OBJ_ADD,
        RRCConnectionReconfigurationMessage_UNPROTECTED_QUANT_CONF,
        RRCConnectionReconfigurationMessage_UNPROTECTED_REPORT_ADD,
        RRCConnectionReconfigurationMessage_NO_INTEGRITY_DESPITE_SECURE,
        RRCConnectionReconfigurationMessage_NO_CIPHERING_DESPITE_SECURE,
        RRCConnectionReconfigurationMessage_WHILE_T304_RUNNING,
        RRCConnectionReconfigurationMessage_WHILE_IDLE,
        RRCConnectionReconfigurationMessage_MOBILITY_CONTROL_NO_SRB2,
        RRCConnectionReconfigurationMessage_MOBILITY_CONTROL_NO_DRB,
        SecurityModeCommandMessage_CIPHER_WITHOUT_INTEGRITY_CONF,
        SecurityModeCommandMessage_AFTER_DRB_CONF,
        SecurityModeCommandMessage_AFTER_SRB2_CONF,
        SecurityModeCommandMessage_AFTER_SECURITY_ENABLED,
        SecurityModeCommandMessage_WHILE_IDLE,
        UECapabilityEnquiryMessage_WHILE_IDLE,
        UECapabilityEnquiryMessage_NO_INTEGRITY_DESPITE_SECURE,
        UECapabilityEnquiryMessage_NO_CIPHERING_DESPITE_SECURE,
        UEInformationRequestMessage_BEFORE_SECURITY,
        UEInformationRequestMessage_NO_INTEGRITY_DESPITE_SECURE,
        UEInformationRequestMessage_NO_CIPHERING_DESPITE_SECURE,
        CounterCheckMessage_SECURITY_DISABLED,
        CounterCheckMessage_NOT_INTEGRITY_PROTECTED,
        CounterCheckMessage_NOT_CIPHERED,
        RRCConnectionRelease_WHILE_IDLE,
        RRCConnectionRelease_NO_INTEGRITY_DESPITE_SECURE,
        RRCConnectionRelease_NO_CIPHERING_DESPITE_SECURE,
        RRCConnectionReestablishment_BEFORE_SECURITY,
        RRCConnectionReject_AFTER_SECURITY
    };
}

#endif