#ifndef SRSEPC_SMS_H
#define SRSEPC_SMS_H

#include "lib/include/srslte/interfaces/epc_interfaces.h"
#include "srsepc/hdr/mme/nas.h"
#include "srsepc/hdr/mme/zmq_channel.h"
#include "srslte/common/buffer_pool.h"
#include "srslte/common/ota_sms.h"

namespace srsepc {

class zmq_channel;

class sms : public nas_interface_sms
{
public:
  void        init(sms_interface_nas* nas_, srslte::log* log_);
  uint8_t     decode_nas_uplink_transport(srslte::byte_buffer_t* nas_msg);
  bool        epc_send_sms(int sms_testcase);
  sms(sms_interface_nas* nas_, srslte::log* log_);
  sms();

private:
  srslte::log*              sms_log;
  static sms*               m_instance;
  srslte::byte_buffer_pool* sms_pool;
  sms_interface_nas*        nas_p;

  void    make_rp_ack(uint8_t* ack, uint8_t ref);
  void    make_sms_deliver(srslte::dtap_data_t* dtap_data, int sms_testcase);
};

} // namespace srsepc
#endif // SRSEPC_SMS_H