#ifndef SRSEPC_MME_ZMQ_H
#define SRSEPC_MME_ZMQ_H

#include <iostream>
#include <string>
#include <zmq.hpp>

#include "srsenb/hdr/stack/rrc/rrc.h"
#include "srslte/common/log.h"
#include "srslte/common/threads.h"
#include "srsepc/hdr/mme/sms.h"

namespace srsepc {

class sms;

//  Provide random number from 0..(num-1)
#define within(num) (int) ((float)((num) * random ()) / (RAND_MAX + 1.0))

//  Receives all message parts from socket, returns as string
inline static std::string s_dump_str (zmq::socket_t & socket)
{
    std::string msg;
    while (1) {
        //  Process all parts of the message
        zmq::message_t message;
        socket.recv(&message);

        //  Dump the message as text or binary
        size_t size = message.size();
        std::string data(static_cast<char*>(message.data()), size);
        msg = msg + data;
        int more = 0;           //  Multipart detection
        size_t more_size = sizeof (more);
        socket.getsockopt (ZMQ_RCVMORE, &more, &more_size);
        if (!more)
            break;              //  Last message part
    }
    return msg;
}

class zmq_channel : public thread
{
public:
  zmq_channel() : thread("ZMQ_CHAN")
  {
    sms_p          = NULL;
    zc_log         = NULL;
    ctx_           = NULL;
    client_socket_ = NULL;
  }

  void init(srslte::log* zc_log_, sms* sms_);
  void send_ul_msg(std::string results);

private:
  // inline static std::string s_dump_str (zmq::socket_t & socket);
  void                      run_thread();
  srslte::log*              zc_log;
  sms*                      sms_p;
  srslte::byte_buffer_pool* pool;
  zmq::context_t*           ctx_;
  zmq::socket_t*            client_socket_;
};
} // namespace srsepc
#endif // SRSEPC_MME_ZMQ_H