
#include "srsepc/hdr/mme/zmq_channel.h"

namespace srsepc {

void zmq_channel::init(srslte::log* zc_log_, sms* sms_)
{
  sms_p           = sms_;
  zc_log         = zc_log_;
  ctx_           = new zmq::context_t(1);
  client_socket_ = new zmq::socket_t(*ctx_, ZMQ_DEALER);
}

void zmq_channel::run_thread()
{
  // generate random identity
  char identity[10] = {};
  sprintf(identity, "%04X-%04X", within(0x10000), within(0x10000));
  zc_log->info("ZMQ channel started.\n");
  client_socket_->setsockopt(ZMQ_IDENTITY, identity, strlen(identity));
  client_socket_->connect("tcp://localhost:5570");
  zmq::pollitem_t items[] = {{static_cast<void*>(*client_socket_), 0, ZMQ_POLLIN, 0}};
  send_ul_msg("Connecting");

  try {
    while (true) {
      for (int i = 0; i < 100; ++i) {
        // 10 milliseconds
        zmq::poll(items, 1, 10);
        if (items[0].revents & ZMQ_POLLIN) {
          std::string str = s_dump_str(*client_socket_);
          if(sms_p != NULL) {
            sms_p->epc_send_sms(std::stoi(str));
          }
          
        }
      }
    }
  } catch (std::exception& e) { }
}

void zmq_channel::send_ul_msg(std::string results)
{
  client_socket_->send(results.c_str(), results.length());
}

} // namespace srsepc